const queryUpdater = require('../model/updaterModel');
const path = require('path');
const fs = require('fs');

class UpdaterController {
  /**
   * @returns versão do Updater
   */
  varsao() {
    return '0.0.1';
  }

  /**
   * @param {*} req
   * @param {*} res
   * @returns Retorna as vendas com problema ou o id e vendas true para sem erros.
   */
  async getUnidades(req, res) {
    try {
      const queryResultAll = await queryUpdater.getUpdaterVersao();

      const { rows } = queryResultAll;
      if (!rows.length) {
        return { };
      }
      const updater = [];
      const ids = [];
      const repetidos = {};
      rows.forEach((item) => {
        let itens = {
          id: item.CDFILIAL,
          IDUPDATER: item.CDFILIAL,
          CDFILIAL: item.CDFILIAL,
          SGESTADO: item.SGESTADO,
          NOMEFILIAL: item.NMFILIAL,
          IDUPDATERSISTEMAS: '-',
          DEVOPSID: '-',
          APLICACAO: '-',
          SERVICO: '-',
          UPSISVERATUAL: '-',
          SISTEMASSTATUS: '-',
          VERSAOATUAL: {},
          STATUS: 0,
        };

        this.versaoDisponivel({serviceId: item.DIRETORIO}, item.UPSISVERATUAL).then((resultVersao) => {
          let ST = 0;
          if(item.SISTEMASSTATUS != '0' || item.SISTEMASSTATUS != 0) {
            const disponivelV = resultVersao.split('.');
            const d = disponivelV.map((word) => word.charAt(0).toUpperCase() + word.slice(1)).join('');
            const disponivel = parseInt(d, 10);

            const atualV = item.UPSISVERATUAL.split('.');
            const a = atualV.map((word) => word.charAt(0).toUpperCase() + word.slice(1)).join('');
            const atual = parseInt(a, 10);

            console.log('Tem atualização: ', disponivel, atual);
            if (disponivel <= atual) {
              resultVersao = '-';
              ST = 3;
            }
          } else {
            resultVersao = 'Instalação pendente';
            ST = 3;
          }

          if(resultVersao === 'Pacote sem informações da aplicação'){
            ST = 2;
          } else if(resultVersao === '-'){
            ST = 3;
          }
          console.log('Resultado::', resultVersao, ST);

          this.getVersaoAtual(item.IDUPDATERSISTEMAS).then((resultss) => {
            if(resultss.UPVERSTATUS === 0){
              resultVersao = 'Atualização pendente para a versão ' + resultVersao;
              ST = 3;
            }else if(resultss.UPVERSTATUS === 3){
              resultVersao = 'Downgrade pendente';
              ST = 3;
            }

            /**
             * Trata o ID para o Item de PARENT_PROJECT
             * ID: 9999, quando repetido vira 9999.x onde x é o número de vezes 9999.1 9999.2 ...
             */
            if (ids.indexOf(item.CDFILIAL) === -1) {
              ids.push(item.CDFILIAL);
              updater.push(itens);

              itens = {
                id: item.CDFILIAL,
                IDUPDATER: item.CDFILIAL,
                CDFILIAL: item.CDFILIAL,
                SGESTADO: item.SGESTADO,
                NOMEFILIAL: item.NMFILIAL,
                IDUPDATERSISTEMAS: item.IDUPDATERSISTEMAS,
                DEVOPSID: item.DEVOPSID,
                APLICACAO: item.APLICACAO,
                SERVICO: item.SERVICO,
                UPSISVERATUAL: item.UPSISVERATUAL,
                SISTEMASSTATUS: item.SISTEMASSTATUS,
                PARENT_PROJECT: item.CDFILIAL,
                UPSISVERDISPONIVEL: resultVersao,
                CDOPERADOR: item.CDOPERADOR,
                UPVERDATA: item.UPVERDATA,
                UPVERSTATUS: item.UPVERSTATUS,
                VERSAOATUAL: {},
                STATUS: ST,
              };
              ids.forEach((i) => {
                repetidos[i] = (repetidos[i] || 0) + 1;
                [repetidos].forEach((it) => {
                  itens.id = item.CDFILIAL + '.' + (it[item.CDFILIAL]);
                });
              });
              updater.push(itens);
            } else {

              ids.push(item.CDFILIAL);
              itens = {
                id: item.CDFILIAL,
                IDUPDATER: item.CDFILIAL,
                CDFILIAL: item.CDFILIAL,
                SGESTADO: item.SGESTADO,
                NOMEFILIAL: item.NMFILIAL,
                IDUPDATERSISTEMAS: item.IDUPDATERSISTEMAS,
                DEVOPSID: item.DEVOPSID,
                APLICACAO: item.APLICACAO,
                SERVICO: item.SERVICO,
                UPSISVERATUAL: item.UPSISVERATUAL,
                SISTEMASSTATUS: item.SISTEMASSTATUS,
                PARENT_PROJECT: item.CDFILIAL,
                UPSISVERDISPONIVEL: resultVersao,
                CDOPERADOR: item.CDOPERADOR,
                UPVERDATA: item.UPVERDATA,
                UPVERSTATUS: item.UPVERSTATUS,
                VERSAOATUAL: {},
                STATUS: ST,
              };
              ids.forEach((i) => {
                repetidos[i] = (repetidos[i] || 0) + 1;
                [repetidos].forEach((it) => {
                  itens.id = item.CDFILIAL + '.' + (it[item.CDFILIAL] -1);
                });
              });
              updater.push(itens);
            }
          });

        }).catch((error) => {
          console.log('ERRO NO BUSCAS SISTEMAS');
          console.log(error);
        });
      });

      return updater;
    } catch (error) {
      console.log(error);
      return error;
    }
  }

  /**
   * Busca pedido de atualizações para a Bolinha do Grid ficar Cinza, caso hava solicitação de atualização
   * @param {*} idsistemas
   * @returns
   */
  async getVersaoAtual(idsistemas) {
    let historico = {};
    if (Number.isInteger(idsistemas)) {
      const queryResultAll = await queryUpdater.getUpdaterVersaoAtual({
        MAX_ROW: 1,
        IDUPDATERSISTEMAS: idsistemas,
      });
      const { rows } = queryResultAll;
      if (!rows.length) {
        return { };
      }

      historico = {
        NMOPERADOR: rows[0].NMOPERADOR,
        CDOPERADOR: rows[0].CDOPERADOR,
        IDUPDATER: rows[0].IDUPDATER,
        CDFILIAL: rows[0].CDFILIAL,
        NOMEFILIAL: rows[0].NOMEFILIAL,
        IDUPDATERSISTEMAS: rows[0].IDUPDATERSISTEMAS,
        DEVOPSID: rows[0].DEVOPSID,
        APLICACAO: rows[0].APLICACAO,
        SERVICO: rows[0].SERVICO,
        UPSISVERATUAL: rows[0].UPSISVERATUAL,
        SISTEMASSTATUS: rows[0].SISTEMASSTATUS,
        IDUPDATERVERSAO: rows[0].IDUPDATERVERSAO,
        UPVERDATA: rows[0].UPVERDATA,
        UPVERSTATUS: rows[0].UPVERSTATUS,
      };
      // console.log('Item::', historico);
    }
    return historico;
  }

  /**
   * Registra o Update do sistema
   * @author Daniel Souza <daniel.souza@teknisa.com>
   * @param {*} data
   * @returns
   */
  async updaterSistemas(data) {
    try {
      console.log('Data 113', data);
      const dia = new Date();
      const dataFormatada = ("0" + dia.getDate()).substr(-2) + "-"  + ("0" + (dia.getMonth() + 1)).substr(-2) + "-" + dia.getFullYear();
      console.log('Data é:', dataFormatada);
      let queryResultAll = {};
      if(Array.isArray(data.dados) === true){
        data.dados.forEach((item) => {
          if(Number.isInteger(item.IDUPDATERSISTEMAS)){
            queryUpdater.setUpdaterVersao({
              IDUPDATERSISTEMAS: item.IDUPDATERSISTEMAS,
              CDOPERADOR: data.operador,
              UPVERDATA: dataFormatada,
              UPVERSTATUS: 0,
            }).then((result) => {
              result.connection.commit();
              console.log('Resultado do commit: ', result);
              queryResultAll = result;
            }).catch((error) => {
              console.log(error);
            });

          }
        });
      } else {
        let queryResultAll = await queryUpdater.setUpdaterVersao({
          IDUPDATERSISTEMAS: data.dados.IDUPDATERSISTEMAS,
          CDOPERADOR: data.operador,
          UPVERDATA: dataFormatada,
          UPVERSTATUS: 0,
        });
        queryResultAll.connection.commit();
        return queryResultAll.rowsAffected;
      }

    } catch (error) {
      return error;
    }
  }

  /**
   * Registra o Downgrade do sistema
   * @author Daniel Souza <daniel.souza@teknisa.com>
   * @param {*} data
   * @returns
   */
   async downgradeSistemas(data) {
    try {
      console.log('Data 113', data);
      const dia = new Date();
      const dataFormatada = ("0" + dia.getDate()).substr(-2) + "-"  + ("0" + (dia.getMonth() + 1)).substr(-2) + "-" + dia.getFullYear();
      let queryResultAll = {};
      if(Array.isArray(data.dados) === true){
        data.dados.forEach((item) => {
          if(Number.isInteger(item.IDUPDATERSISTEMAS)){
            queryUpdater.setDowngradeVersao({
              IDUPDATERSISTEMAS: item.IDUPDATERSISTEMAS,
              CDOPERADOR: data.operador,
              UPVERDATA: dataFormatada,
              UPVERSTATUS: 3,
            }).then((result) => {
              result.connection.commit();
              console.log('Resultado do commit: ', result);
              queryResultAll = result;
            }).catch((error) => {
              console.log(error);
            });

          }
        });
      } else {
        let queryResultAll = await queryUpdater.setDowngradeVersao({
          IDUPDATERSISTEMAS: data.dados.IDUPDATERSISTEMAS,
          CDOPERADOR: data.operador,
          UPVERDATA: dataFormatada,
          UPVERSTATUS: 3,
        });
        queryResultAll.connection.commit();
        return queryResultAll.rowsAffected;
      }

    } catch (error) {
      return error;
    }
  }

  /**
   * Historico de atualizações
   * @param {*} req
   * @param {*} res
   * @returns
   */
  async getHistorico(data) {
    try {
      const historico = [];
      const queryResultAll = await queryUpdater.getUpdaterVersaoAll({
        MAX_ROW: data.dados.MAX_ROW,
        IDUPDATERSISTEMAS: data.dados.IDUPDATERSISTEMAS,
        CDFILIAL: data.dados.CDFILIAL,
      });

      const { rows } = queryResultAll;
      if (!rows.length) {
        return { };
      }
      rows.forEach((item) => {
        historico.push({
          NMOPERADOR: item.NMOPERADOR,
          CDOPERADOR: item.CDOPERADOR,
          IDUPDATER: item.CDFILIAL,
          CDFILIAL: item.CDFILIAL,
          NOMEFILIAL: item.NOMEFILIAL,
          IDUPDATERSISTEMAS: item.IDUPDATERSISTEMAS,
          DEVOPSID: item.DEVOPSID,
          APLICACAO: item.APLICACAO,
          SERVICO: item.SERVICO,
          UPSISVERATUAL: item.UPSISVERATUAL,
          SISTEMASSTATUS: item.SISTEMASSTATUS,
          IDUPDATERVERSAO: item.IDUPDATERVERSAO,
          UPVERDATA: item.UPVERDATA,
          UPVERSTATUS: item.UPVERSTATUS,
        });
      });

      return rows; //historico;
    } catch (error) {
      console.log(error);
      return error;
    }
  }

  /**
   * @author Daniel Souza <daniel.souza@teknisa.com>
   * @param {*} data
   * @returns obj lista de sistemas a serem atualizados
   */
  async getVersaoDisponivel(data) {
    const queryResultAll = await queryUpdater.getVersaoDisponivel(data);
    const { rows } = queryResultAll;
    const services = [];
    //console.log('Rows::', rows);
    if (rows.length === 0) {
      return false;
    }
    rows.forEach((item) => {
      services.push({
        'id': item.DIRETORIO,
        'IDUPDATERVERSAO': item.IDUPDATERVERSAO,
        'IDUPDATERSISTEMAS': item.IDUPDATERSISTEMAS,
      });
    });
    //console.log('Services::', services);
    //return false;
    return services;
  }

    /**
   * @author Daniel Souza <daniel.souza@teknisa.com>
   * @param {*} data
   * @returns obj lista de sistemas a terem downgrade
   */
     async getVersaoDowngrade(data) {
      const queryResultAll = await queryUpdater.getVersaoDowngrade(data);
      const { rows } = queryResultAll;
      const services = [];
      //console.log('Rows::', rows);
      if (rows.length === 0) {
        return false;
      }
      rows.forEach((item) => {
        services.push({
          'id': item.DIRETORIO,
          'IDUPDATERVERSAO': item.IDUPDATERVERSAO,
          'IDUPDATERSISTEMAS': item.IDUPDATERSISTEMAS,
        });
      });
      //console.log('Services::', services);
      //return false;
      return services;
    }

  /**
   * @author Daniel Souza <daniel.souza@teknisa.com>
   * @param {*} data
   * @returns Atualiza a lista de sistemas a serem atualizados
   */
   async updateVersaoDisponivel(data) {
    const queryResultAll = await queryUpdater.updateVersaoDisponivel(data);
    queryResultAll.connection.commit();
    return queryResultAll;
  }

    /**
   * @author Daniel Souza <daniel.souza@teknisa.com>
   * @param {*} data
   * @returns Atualiza a versão do sistema
   */
     async updateVersaoAtual(data) {
      const queryResultAll = await queryUpdater.updateVersaoAtual(data);
      queryResultAll.connection.commit();
      return queryResultAll;
    }

 /**
 * @version 1
 * @param {*} version
 * @returns 3006000 (3.6.0)
 */
  async formatVersion(version) {
    if (!version) {
      return null;
    }

    const versionParts = version.split('.').map((v) => {
      return v.padStart(3, '0');
    });

    return parseInt(versionParts.join(''), 10);
  }

  /**
   * Versão disponível
   * @param {*} data serviceId=odhen-updater
   * @returns
   */
  async versaoDisponivel(data, versaoAtual) {
    console.log('latest:', data);

    let serviceId = '';
    const aplicacao = data.serviceId;
    // console.log('latest:', req);

    if (typeof data.serviceId === 'string') {
      serviceId = data.serviceId;
    }

    if (!serviceId) {
      return '-';
    }

    /** Repositório */
    const dirApp = '../../../../assistant-sistemas/';
    let dir = `${dirApp + aplicacao}`;

    dir = path.join(__dirname, dir); console.log(dir);
    /** Se não existe o arquivo retorna 400 */
    console.log(`${dir}/productInfo.json`);
    if (!fs.existsSync(`${dir}/productInfo.json`)) {
      return 'Pacote sem informações da aplicação';
    }
    const productInfo = JSON.parse(fs.readFileSync(`${dir}/productInfo.json`));

    if (!productInfo) {
      return false;
    }

    let { version } = productInfo.product;
    if (!version) {
      return 'Pacote sem informações de versão';
    }

    let versionString = this.formatVersion(version);
    let antiga = this.formatVersion(versaoAtual);
    if (versionString < antiga) {
      return '';
    }

    return version;
  }
}

module.exports = new UpdaterController();
