const installerController = require('../../controller/InstallerController');

const route = (router) => {
  router.put('/installer/*', (async (req, res) => {
    console.log('/installer/:', req.body);
    
    installerController.upInstaller(req.body).then((services) => {
      if (services.rowsAffected > 0) {
        return res.status(200).json({ data: services.rowsAffected });
      }

      return res.status(400).json({ error: 'Dados incorretos' });
    }).catch((err) => {
      return res.status(400).json({ error: 'Erro ao atualizar o sistema no banco de dados' });
    });
  }));

  router.post('/installer/*', (async (req, res) => {
    console.log('/installer/:', req.body);
    
    installerController.addInstaller(req.body).then((services) => {
      if (services.rowsAffected > 0) {
        return res.status(200).json({ data: services.rowsAffected });
      }

      return res.status(400).json({ error: 'Dados incorretos' });
    }).catch((err) => {
      console.log('/installer/: - Erro: ', err);
      return res.status(400).json({ error: 'Erro ao atualizar o sistema no banco de dados' });
    });
  }));
}

module.exports = route;