const OracleService = require('../service/OracleService');

class installerModel {
  constructor() {

   /**
    * Retorna os sistemas a serem instalados para cilial cdFilial
    */
   this.GET_UPDATER_ESPERA_ALL = `
   SELECT UPS.APLICACAO, UPS.IDUPDATERSISTEMAS, UPS.DIRETORIO
      FROM
        FILIAL F INNER JOIN
        UPDATERSISTEMAS UPS ON (F.CDFILIAL = UPS.CDFILIAL)

      WHERE
        F.CDFILIAL = :cdfilial AND
        UPS.SISTEMASSTATUS = 0 AND
        UPS.DIRETORIO IS NOT NULL
      GROUP BY UPS.APLICACAO, UPS.IDUPDATERSISTEMAS, UPS.DIRETORIO
   `;

   this.ADD_UPDATERSISTEMAS = `
    INSERT INTO UPDATERSISTEMAS
                (CDFILIAL,   DEVOPSID,  SISTEMASSTATUS,  APLICACAO,  DIRETORIO, UPSISVERATUAL)
         VALUES (:CDFILIAL, :DEVOPSID, :SISTEMASSTATUS, :APLICACAO, :DIRETORIO, :UPSISVERATUAL)
  `;

   this.UP_UPDATERSISTEMAS = `
      UPDATE UPDATERSISTEMAS
         SET SISTEMASSTATUS = 2,
         UPSISVERATUAL = :UPSISVERATUAL
       WHERE IDUPDATERSISTEMAS = :IDUPDATERSISTEMAS
  `;
  }

  getDisponivel(params) {
    return OracleService.getNewConnection().then(() => {
      return OracleService.fetchAssoc(this.GET_UPDATER_ESPERA_ALL, params);
    });
  }

  addInstaller(params) {
    return OracleService.getNewConnection().then(() => {
      return OracleService.execute(this.ADD_UPDATERSISTEMAS, params);
    });
  }

  upInstaller(params) {
    //return OracleService.execute(this.UP_UPDATERSISTEMAS, params, [], false, connection);
    return OracleService.getNewConnection().then(() => {
      return OracleService.execute(this.UP_UPDATERSISTEMAS, params);
    });
  }

}

module.exports = new installerModel();
